/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/internal/ShaderVariableImpl.h>
#include <glint/internal/ProgramImpl.h>
#include <glint/GlintExceptions.h>

#include <cassert>
#include <sstream>

using namespace std;

namespace glint
{

namespace internal
{

ShaderVariableImpl::
ShaderVariableImpl(GLuint prog_id, GLint location, const string& name, GLenum type, GLint size) noexcept
    : prog_id_(prog_id), location_(location), name_(name), type_(type), size_(size)
{
    assert(prog_id != 0);
    assert(location >= 0);
    assert(!name.empty());
    assert(size > 0);
}

ShaderVariableImpl::
~ShaderVariableImpl() = default;

} // namespace internal

} // namespace glint
